import 'dart:math';
import 'NE_PAS_TOUCHER/user_input.dart';

class Date {
  Date({int? day = 9, int? month = 11, int? year = 1965})
      : _year = year,
        _month = month,
        _day = day;

  int? _day;
  int? _month;
  int? _year;

  int? get day => _day;
  int? get month => _month;
  int? get year => _year;

  set day(int? day) {
    _day = min(max(1, day!), getDayMax());
  }

  set month(int? month) {
    _month = min(max(1, month!), 12);
  }

  set year(int? year) {
    _year = max(min(year!, 2050), 1900);
  }

  String displayDate() {
    if (day! < 10 && month! < 10) {
      return ('0$day/0$month/$year');
    } else if (day! < 10 && month! > 9) {
      return ('0$day/$month/$year');
    } else if (day! > 9 && month! < 10) {
      return ('$day/0$month/$year');
    } else {
      return ('$day/$month/$year');
    }
  }

  void userData() {
    var userChoice;
    do {
      userChoice =
          readText("Souhaitez-vous entrez manuellement les valeurs ? (o/n)");
      userChoice = userChoice.toLowerCase(); //force les minuscules si besoin
    } while (userChoice != "o" && userChoice != "n");

    if (userChoice == "o") {
      this.year = readInt("Année : ");

      do {
        this.month = readInt("Mois : ");
      } while (this.month! < 1 || this.month! > 12);

      do {
        this.day = readInt("Jour : ");
      } while (this.day! < 1 || this.day! > getDayMax());
    } else {
      final now = DateTime.now();
      this.day = now.day;
      this.month = now.month;
      this.year = now.year;
    }
  }

  int getDayMax() {
    int dayMax = 31;
    if (this.month == 4 ||
        this.month == 6 ||
        this.month == 9 ||
        this.month == 11) {
      dayMax = 30;
    } else if (this.month == 2) {
      if (leapYear()) {
        dayMax = 29;
      } else {
        dayMax = 28;
      }
    }
    return dayMax;
  }

  bool moreRecent(Date date) {
    if (this.year! > date.year!) {
      return true;
    } else if (this.year! == date.year! && this.month! > date.month!) {
      return true;
    } else if (this.year! == date.year! &&
        this.month! == date.month! &&
        this.day! > date.day!) {
      return true;
    } else {
      return false;
    }
  }

  bool leapYear() =>
      (this.year! % 4 == 0 && (this.year! % 100 != 0 || this.year! % 400 == 0));
}
